#!/usr/local/bin/perl
##########################################################################
# FrameIt 4.0a
# written by Jason M. Hinkle: http://www.verysimple.com/scripts/
# please read the legal information in readme.txt, inluded with this file.
# use of this script implies agreement to the legal terms in readme.txt.
#
# parse_input and check_referer are modified versions of subroutines
# originally written by Matt Wright: http://worldwidemart.com/scripts/
#       : WWW: 
#     Ƨ@: Jonas teng  Hc : tengcy@pcmail.com.tw
##########################################################################
# CONFIGURATION VARIABLES:

# $frameit_url is the URL to the script so that it can refer to itself.
$frameit_url = "./Frameit.cgi";

# @referers is a list of domains that can use this script
# W	*
@referers = ('jonas11.hypermart.net','jonas12.hypermart.net');

# END OF CONFIGURATION VARIABLES
##########################################################################

# Required Librariers
# --------------------------------------------------------
eval {
	($0 =~ m,(.*)/[^/]+,)   && unshift (@INC, "$1");	# Get the script location: UNIX /
	($0 =~ m,(.*)\\[^\\]+,) && unshift (@INC, "$1");	# Get the script location: Windows \

	require "admin/links.cfg";			  # Change this to full path to links.cfg if you have problems.
	require "$db_lib_path/db.pl";
        require "$db_lib_path/site_html.pl";
};
if ($@) {
	print "Content-type: text/plain\n\n";
	print "Error including libraries: $@\n";
	print "Make sure they exist, permissions are set properly, and paths are set correctly.";
}

# ========================================================
# Parse Input
&read_parse(*Form);

if ($Form{footer} eq 'YES') {
    # Output Footer
    &output_footer;
	}

else {

	# Check refering URL
	&check_referer;

	# Output HTML
	&output_html;
	}


##########################################################################

sub check_referer {

    # Localize the check_referer flag which determines if user is valid.     #
    local($check_referer) = 0;

    # If a referring URL was specified, for each valid referer, make sure    #
    # that a valid referring URL was passed to FormMail.                     #

    if ($ENV{'HTTP_REFERER'}) {
        foreach $referer (@referers) {
            if ($ENV{'HTTP_REFERER'} =~ m|https?://([^/]*)$referer|i) {
                $check_referer = 1;
                last;
            }
        }
    }
    else {
        $check_referer = 1;
    }

    # If the HTTP_REFERER was invalid, send back an error.                   #
    if ($check_referer != 1) { &error('ERROR: Your domain is not authorized to use this script.') }
}

##########################################################################

# ---------------------------------------------------------------------------
# read_parse v1.1
# Copyright (c) 1998 Jason M. Hinkle
# http://www.verysimple.com/scripts/
# Based on ReadParse v1.14, Copyright (c) 1995 Steven E. Brenner
# Reads in GET, POST or UNIX command line data
# 
# See configuration variable (below) to accept command line input.
# ---------------------------------------------------------------------------
sub read_parse {
  # check if an alternate name is use and localize variables
  local (*in) = @_ if @_;
  local ($i, $key, $val, $accept_command);

  # Global variables returned: $in{field_name}, $method

  # -----------------------------------------------------------------------
  # CONFIGURATION VARIABLE FOR READ_PARSE:
  # -----------------------------------------------------------------------
  # $accept_command = 1 (to accept command line input) or
  # $accept_command = 0 (to block command line input)
  $accept_command = 0;

  # set some global variables
  $method = $ENV{'REQUEST_METHOD'};
  $length  = $ENV{'CONTENT_LENGTH'};

  # determine the request method and read in the text
  
  # check to see if command line data was entered
  if (!defined $method || $method eq '') {
    if ($accept_command) {
        push(@in, @ARGV);
        $method = "COMMAND";  # also use command-line options
    } else {
        die("ERROR: Command line input not accepted\n")
    }
  
  # check to see if data was submitted via GET
  } elsif($method eq 'GET' || $method eq 'HEAD') {
    $in = $ENV{'QUERY_STRING'};
    @in = split(/[&;]/,$in);
  
  # check to see if data was submitted via POST
  } elsif ($method eq 'POST') {
    if (($got = read(STDIN, $in, $length) != $length)) {
      $errflag="Short Read: wanted $length, got $got\n"
    };
    @in = split(/[&;]/,$in);
  
  # otherwise, what the...?
  } else {
    $errflag="Unknown request method: $method\n";
  }

  # Change all the funky characters back to english and assign the variables
  foreach $i (0 .. $#in) {
    # Convert plus's to spaces
    $in[$i] =~ s/\+/ /g;

    # Split into key and value.
    ($key, $val) = split(/=/,$in[$i],2); # splits on the first =.

    # Convert %XX from hex numbers to alphanumeric
    $key =~ s/%(..)/pack("c",hex($1))/ge;
    $val =~ s/%(..)/pack("c",hex($1))/ge;

    # Associate key and value
    $in{$key} .= "\0" if (defined($in{$key})); # \0 is the multiple separator
    $in{$key} .= $val;

  }

  # return the variables using the array name given, or @in
  return scalar(@in);
}

##########################################################################

sub output_html {

	if ($Form{ID} eq '') {
    	&error('<A HREF=\$build_root_url\">Aгy@ӿ~ - ^</A>')
	}
	
	if ($Form{url} eq '') {
    	&error('<A HREF=\$build_root_url\">Aгy@ӿ~ - ^</A>')
	}
	
	if ($Form{text} eq '') {$text = qq~ <font size=1> ^</font> ~;
	}
		else {$text = $Form{text}
		}

# Get the redirect URL

	if ($Form{override_footer} eq '') {$footer_url = $frameit_url
	}
		else {$footer_url = $Form{override_footer}
		}


	if ($Form{override_link} eq '') {$linkback = $ENV{'HTTP_REFERER'}
	}
		else {$linkback = $Form{override_link}
		}
	
$footer = $footer_url . "?footer=YES" . "&back=" . $linkback . "&remove=" . $Form{remove} . "&url=" . $Form{url} . "&ID=" . $Form{ID};


	# Output the HTML
	print "Content-type: text/html\n\n";
	print "<html>\n";
	
	print "<frameset rows=\"92%,*\">\n";
	print "<frame name=\"top\" src=\"$Form{url}\" marginwidth=\"0\" marginheight=\"0\" scrolling=\"auto\" frameborder=\"yes\" noresize>\n";
	print "<frame name=\"bottom\" src=\"$footer\" marginwidth=\"0\" marginheight=\"0\" scrolling=\"auto\" frameborder=\"yes\" noresize>\n";

	print "\n";
	print "<noframes>\n";
	print "<body bgcolor=\"#FFFFFF\" LINK=\"Blue\" ALINK=\"Teal\" VLINK=\"Blue\" text=\"Navy\">\n";

	print "A{bw}ڭ̪! nѰOXڭ̪\n";
	print "b: <a href=\"$linkback\">$linkback</a>\n";
	print "<p>\n";
	print "<a href=\"$Form{url}\">o~</a>\n";
	print "</noframes>\n";

	print "\n";
	print "</frameset>\n";

	print "</html>\n";
}



##########################################################################

sub error {
    local($error,@error_fields) = @_;

	print "Content-type: text/html\n\n";
	print "<b><html></b>\n";
	print "<b><body bgcolor=\"#FFFFFF\"></b>\n";
	print "<b>$error</b>";

    exit;
}

##########################################################################
