#!/usr/local/bin/perl
#			   -------------
#			      Links
#			   -------------
#			   Links Manager
#
#		 File: jump.cgi
#  Description: Increments the number of hits for the specified link, 
#			   and sends the user off to the appropriate page.
#	   Author: Alex Krohn
#		Email: alex@gossamer-threads.com
#		  Web: http://www.gossamer-threads.com/
#          : WWW: 
#       Ƨ@: Jonas teng  Hc : tengcy@pcmail.com.tw
#	  Version: 4.0a
#
# COPYRIGHT NOTICE:
#
# Copyright 1997 Gossamer Threads Inc.  All Rights Reserved.
#
# This program is being distributed as shareware.  It may be used and
# modified free of charge for personal, academic, government or non-profit
# use, so long as this copyright notice and the header above remain intact.
# Any commercial use should be registered.  Please also send me an email,
# and let me know where you are using this script. By using this program 
# you agree to indemnify Gossamer Threads Inc. from any liability.
#
# Selling the code for this program without prior written consent is
# expressly forbidden.  Obtain written permission before redistributing this
# program over the Internet or in any other medium.  In all cases
# copyright and header must remain intact.
#
# Please check the README file for full details on registration.
# =====================================================================
#
#   Form Input: 
#	   '$db_key'   = key number		# Send as form input the key name and key value
#									  # of the link you want to go to.
#
#   Setup:
#	   Make sure the require statement below points to the config file.	

# Required Librariers
# --------------------------------------------------------
eval {
	($0 =~ m,(.*)/[^/]+,)   && unshift (@INC, "$1");	# Get the script location: UNIX /
	($0 =~ m,(.*)\\[^\\]+,) && unshift (@INC, "$1");	# Get the script location: Windows \

	require "admin/links.cfg";			  # Change this to full path to links.cfg if you have problems.
	require "$db_lib_path/db.pl";
};
if ($@) {
	print "Content-type: text/plain\n\n";
	print "Error including libraries: $@\n";
	print "Make sure they exist, permissions are set properly, and paths are set correctly.";
}

# ========================================================

eval { &main; };						 # Trap any fatal errors so the program hopefully 
if ($@) { &cgierr("fatal error: $@"); }	 # never produces that nasty 500 server error page.
exit;   # There are only two exit calls in the script, here and in in &cgierr. 

sub main {
# --------------------------------------------------------
	local (%in) = &parse_form;
	my (@lines, @iplines, $key, @fields, $url, $goto, %tmp, $line_number);
	my ($time) = time();

# If we get a random link, then we don't update the hit counter, let's
# just find the link and go.
	if ($in{$db_key} eq "random") {
		my ($random_link) = -1;
		open  (URL, "<$db_url_name")   or &cgierr("Lk}: $db_url_name. z: $!");
		flock (URL, 1) if ($db_use_flock);
		@lines = <URL>;
		close URL;
		srand;
		$random_link = int (rand($#lines + 0.5));
		($key, $url, $hits, $timestamp, @IP) = split (/\Q$db_delim\E/, $lines[$random_link]);
		$goto = $url;
	}
# Otherwise we are just looking for a regular ID, so let's find it and update the URL counter.
	elsif (exists $in{$db_key}) {
		$time = time();

# URL database stores a list of keys, URLS, timestamp, and IP addresses.
		open  (URL, "+>>$db_url_name")   or &cgierr("unable to open url index $db_url_name. Reason: $!");
		if ($db_use_flock) {
		   flock (URL, 2) or &cgierr("Lkoƥ~.z: $!");
		}
		seek  (URL, 0, 0);	  # rewind to begining.

# Go through the URL database and find the link we want to go to.
		$visited = 0;
		LINE: while (<URL>) {
			next LINE if (/^#/);		# Skip comment lines.
			next LINE if (/^\s*$/);		# Skip blank lines.
			$line = $_;
			chomp ($line);
			
			($key, $url, $hits, $timestamp, @IP) = split (/\Q$db_delim\E/, $line);
			$key = int($key); $hits = int($hits);

# If this is the key we are looking for, or this is the line number we want..   
			if ($key == $in{$db_key}) {
# Then if it hasn't been visited in 6 hours, we wipe out the list of IP addresses.
				if (($time - $timestamp) > 21600) { @IP = (); }
# Let's just make sure there is no line breaks in the remote_addr as that could mess
# up the database.
				$ENV{'REMOTE_ADDR'} =~ s/\n//g; $ENV{'REMOTE_ADDR'} =~ s/\r//g;				
				
# Otherwise we go through all the IP addresses and check to see if the current
# visitor has been here in the last 6 hours. If yes we mark visted = 1.
				IP: foreach $IP (@IP) {			 
					if ($IP eq $ENV{'REMOTE_ADDR'}) {
						$visited = 1;
						last IP;
					}
				}
# We only increase the hits if this is a new visitor.				
				push (@IP, $ENV{'REMOTE_ADDR'}) unless ($visited);
				$hits = $hits + 1 				unless ($visited);
				$timestamp = $time;
				$goto = $url;
			}
# We rebuild the URL database..
			$output .= "$key$db_delim$url$db_delim$hits$db_delim$timestamp$db_delim";
			$output .= join ("$db_delim", @IP); 
			$output .= "\n";
		}
# And print it out again..  
		seek (URL, 0, 0)				or &cgierr("Lk¶ url ɮ.z: $!");
		truncate (URL, 0)	  			or &cgierr("LkohYɮ.z: $!");
		print URL $output;	 # Print new output.
		close URL					    or &cgierr("LkoɮשMo.z: $!");		
	}
# Ooops, no record specified.
	else {
		print "Content-type: text/plain\n\n";
		print "Error: No record specified!";
		return;
	}	
# Now let's send the user to the url..
	if ($goto) {
              if ($in{'HM'}) { print "Location: $build_root_url\n\n"; }
              else { print "Location: $goto\n\n"; } 
	}
	else {
		print "Content-type: text/plain\n\n";
		print "Error: Record not found ($in{$db_key})!";
	}
}
